// GotoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "GotoDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGotoDlg dialog

extern int gblPortNo;
extern int count;
extern int in;
extern int out;
extern BYTE data[255];
extern long gblCurWL;


CGotoDlg::CGotoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGotoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGotoDlg)
	m_lGotoWL = 0;
	m_iStatus = 0;
	m_iCancel = 0;
	m_iGotoCancel = 0;
	m_iGotoStatus = 0;
	m_lGotoTOut = 0;
	//}}AFX_DATA_INIT
}


void CGotoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGotoDlg)
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Control(pDX, IDC_MSCOMM1, m_Comm);
	DDX_Text(pDX, IDC_GOTOWL, m_lGotoWL);
	DDV_MinMaxLong(pDX, m_lGotoWL, 0, 16777215);
	DDX_Text(pDX, IDC_GOTOCANCEL, m_iGotoCancel);
	DDX_Text(pDX, IDC_GOTOSTATUS, m_iGotoStatus);
	DDX_Text(pDX, IDC_GOTOTOUT, m_lGotoTOut);
	DDV_MinMaxLong(pDX, m_lGotoTOut, 0, 3599);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGotoDlg, CDialog)
	//{{AFX_MSG_MAP(CGotoDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGotoDlg message handlers


BOOL CGotoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	m_Comm.SetCommPort(gblPortNo);
	m_Comm.SetSettings("9600,n,8,1");
	m_Comm.SetRTSEnable(TRUE);
	m_Comm.SetPortOpen(TRUE);
	m_Comm.SetInputMode(1);

	count=0;
	in=0;
	out=0;
	
	m_lGotoTOut=2;	// Initialize to 100s.
	m_lGotoWL=gblCurWL;
	// Update the dialog
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

int CGotoDlg::Buffer_Empty_Q()
{
	/* Return <> 0  if buffer is empty */
	return(count == 0);	
}

BYTE CGotoDlg::Dequeue_Buffer()
{
  /* Returns a byte from queue, MUST NOT BE EMPTY! */
  count--;
  out++;
  if ( out == 255 )
	 out = 0;
  return data[out] ;
}

void CGotoDlg::RcvCOM()
{
	COleVariant myVar;
	int hr;
	long lLen=0;
	myVar=m_Comm.GetInput();
	hr=SafeArrayGetUBound(myVar.parray, 1, &lLen);
	if( hr==S_OK)
	{
		lLen++;	//upper bound is zero based index
		// lock array so you can access it
		BYTE *pAccess;
		hr=SafeArrayAccessData(myVar.parray, (void**)&pAccess);

		if(hr==S_OK)
		{
			// Make a copy of data
			// Note: Need to check that lLen is < buffer length
			// so you don't overrun the buffer.
			for( int i=0; i<lLen; i++)
			{
				if(count<255)
				{
					count++;
					in++;
					if(in==255)
					  in=0;
					data[in]=pAccess[i];
				}
			}
			// unlock the data
			SafeArrayUnaccessData(myVar.parray);
		}
	}
}

void CGotoDlg::XmtCOM(unsigned char b)
{
	CByteArray arrBytes;
	arrBytes.Add(b);
	m_Comm.SetOutput(COleVariant(arrBytes));
}

void CGotoDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	// VB use time 100s. Use 2ms for Echo only
	BYTE IDcmd, EchoB, StatusB;
	BYTE HiB, MiB, LoB;

	time_t start, finish;
	long timeout;
	double elapsed_time;

	// Update the variable
	UpdateData(TRUE);
	timeout=m_lGotoTOut;		//2s

	SetDlgItemText(IDC_GOTOSTATUS,"0");
	SetDlgItemText(IDC_GOTOCANCEL,"0");

	m_cOK.EnableWindow(FALSE);
	
	IDcmd=16;
	XmtCOM(IDcmd);
	time( &start );
	do
	{
		RcvCOM();
		time( &finish );
		elapsed_time = difftime( finish, start );
	}
	while((Buffer_Empty_Q())&&(elapsed_time < timeout));
	if(elapsed_time < timeout)
	{
		EchoB=Dequeue_Buffer();
		if(EchoB != IDcmd)
		{
			MessageBox("An error has occurred !",
				"NO EchoByte",
				MB_ICONSTOP);
		}

		HiB=m_lGotoWL / 65536;
		MiB=(m_lGotoWL - 65536 * HiB) / 256 ;
		LoB=(m_lGotoWL - (65536 * HiB + 256 * MiB));

		XmtCOM(HiB);	XmtCOM(MiB);	XmtCOM(LoB);

		while(Buffer_Empty_Q())
			RcvCOM();
		StatusB=Dequeue_Buffer();
		m_iGotoStatus=StatusB;
		// Update dialog
		UpdateData(FALSE);

		while(Buffer_Empty_Q())
			RcvCOM();
		m_iGotoCancel=Dequeue_Buffer();
		// Update dialog
		UpdateData(FALSE);

		if (StatusB <= 127)
		{
			gblCurWL = m_lGotoWL;
		}
		else
		{
			if ( (StatusB & 64)==0)
			MessageBox("An error has occurred !",
				"Status >= 128",
				MB_ICONSTOP);
			else
				gblCurWL = m_lGotoWL;
		}
	
	}
	else
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	m_cOK.EnableWindow(TRUE);
}
