// GrtSelDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "GrtSelDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGrtSelDlg dialog

extern int gblPortNo;
extern int count;
extern int in;
extern int out;
extern BYTE data[255];
extern long gblNGrtSelted;

CGrtSelDlg::CGrtSelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGrtSelDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGrtSelDlg)
	m_iGrtSelCancel = 0;
	m_iGrtSelNew = 0;
	m_iGrtSelStatus = 0;
	m_lGrtSelTOut = 2;
	//}}AFX_DATA_INIT
}


void CGrtSelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGrtSelDlg)
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Text(pDX, IDC_GRTSELCANCEL, m_iGrtSelCancel);
	DDX_Text(pDX, IDC_GRTSELNEW, m_iGrtSelNew);
	DDX_Text(pDX, IDC_GRTSELSTATUS, m_iGrtSelStatus);
	DDX_Text(pDX, IDC_GRTSELTOUT, m_lGrtSelTOut);
	DDX_Control(pDX, IDC_MSCOMM1, m_Comm);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGrtSelDlg, CDialog)
	//{{AFX_MSG_MAP(CGrtSelDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGrtSelDlg message handlers


BOOL CGrtSelDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	m_Comm.SetCommPort(gblPortNo);
	m_Comm.SetSettings("9600,n,8,1");
	m_Comm.SetRTSEnable(TRUE);
	m_Comm.SetPortOpen(TRUE);
	m_Comm.SetInputMode(1);

	count=0;
	in=0;
	out=0;

	m_iGrtSelNew = gblNGrtSelted;
	// Update the dialog
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


int CGrtSelDlg::Buffer_Empty_Q()
{
	/* Return <> 0  if buffer is empty */
	return(count == 0);	
}

BYTE CGrtSelDlg::Dequeue_Buffer()
{
  /* Returns a byte from queue, MUST NOT BE EMPTY! */
  count--;
  out++;
  if ( out == 255 )
	 out = 0;
  return data[out] ;
}

void CGrtSelDlg::RcvCOM()
{
	COleVariant myVar;
	int hr;
	long lLen=0;
	myVar=m_Comm.GetInput();
	hr=SafeArrayGetUBound(myVar.parray, 1, &lLen);
	if( hr==S_OK)
	{
		lLen++;	//upper bound is zero based index
		// lock array so you can access it
		BYTE *pAccess;
		hr=SafeArrayAccessData(myVar.parray, (void**)&pAccess);

		if(hr==S_OK)
		{
			// Make a copy of data
			// Note: Need to check that lLen is < buffer length
			// so you don't overrun the buffer.
			for( int i=0; i<lLen; i++)
			{
				if(count<255)
				{
					count++;
					in++;
					if(in==255)
					  in=0;
					data[in]=pAccess[i];
				}
			}
			// unlock the data
			SafeArrayUnaccessData(myVar.parray);
		}
	}
}

void CGrtSelDlg::XmtCOM(unsigned char b)
{
	CByteArray arrBytes;
	arrBytes.Add(b);
	m_Comm.SetOutput(COleVariant(arrBytes));
}


void CGrtSelDlg::OnOk() 
{
	// TODO: Add your control notification handler code here

	BYTE IDcmd, EchoB, StatusB;
	BYTE GrtN;
	
	time_t start, finish;
	long timeout;
	double elapsed_time;

	// Update the variable
	UpdateData(TRUE);
	timeout=m_lGrtSelTOut;		//2s

	SetDlgItemText(IDC_GRTSELSTATUS,"0");
	SetDlgItemText(IDC_GRTSELCANCEL,"0");

	m_cOK.EnableWindow(FALSE);
	
	
	IDcmd=26;
	XmtCOM(IDcmd);
	time( &start );
	do
	{
		RcvCOM();
		time( &finish );
		elapsed_time = difftime( finish, start );
	}
	while((Buffer_Empty_Q())&&(elapsed_time < timeout));
	if(elapsed_time < timeout)
	{
		EchoB=Dequeue_Buffer();
		if(EchoB != IDcmd)
		{
			MessageBox("An error has occurred !",
				"NO EchoByte",
				MB_ICONSTOP);
		}

		GrtN = m_iGrtSelNew;
		XmtCOM(GrtN);

		while(Buffer_Empty_Q())
			RcvCOM();
		StatusB=Dequeue_Buffer();
		m_iGrtSelStatus=StatusB;
		// Update dialog
		UpdateData(FALSE);

		while(Buffer_Empty_Q())
			RcvCOM();
		m_iGrtSelCancel=Dequeue_Buffer();
		// Update dialog
		UpdateData(FALSE);

		if (StatusB <= 127)
		{
			gblNGrtSelted = m_iGrtSelNew;
		}
		else
		{
			if ( (StatusB & 64)==0)
			MessageBox("An error has occurred !",
				"Status >= 128",
				MB_ICONSTOP);
			else
				gblNGrtSelted = m_iGrtSelNew;
		}
	
	}
	else
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	m_cOK.EnableWindow(TRUE);
	
}
