// NovramRdDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "NRdDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNRdDlg dialog

extern int gblPortNo;
extern int count;
extern int in;
extern int out;
extern BYTE data[255];


CNovramRdDlg::CNovramRdDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNovramRdDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNovramRdDlg)
	m_iNRdAddress = 1;
	m_iNRdData = 0;
	m_sNRdDataHex = _T("0");
	m_lNRdTOut = 2;
	m_iNRdCancel = 0;
	m_iNRdStatus = 0;
	//}}AFX_DATA_INIT
}


void CNovramRdDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNovramRdDlg)
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Control(pDX, IDC_MSCOMM1, m_Comm);
	DDX_Text(pDX, IDC_NRDADDRESS, m_iNRdAddress);
	DDV_MinMaxInt(pDX, m_iNRdAddress, 1, 64);
	DDX_Text(pDX, IDC_NRDDATA, m_iNRdData);
	DDV_MinMaxInt(pDX, m_iNRdData, 0, 65535);
	DDX_Text(pDX, IDC_NRDDATAHEX, m_sNRdDataHex);
	DDX_Text(pDX, IDC_NRDTOUT, m_lNRdTOut);
	DDV_MinMaxLong(pDX, m_lNRdTOut, 0, 3599);
	DDX_Text(pDX, IDC_NRDCANCEL, m_iNRdCancel);
	DDX_Text(pDX, IDC_NRDSTATUS, m_iNRdStatus);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNovramRdDlg, CDialog)
	//{{AFX_MSG_MAP(CNovramRdDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNovramRdDlg message handlers

BOOL CNovramRdDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	m_Comm.SetCommPort(gblPortNo);
	m_Comm.SetSettings("9600,n,8,1");
	m_Comm.SetRTSEnable(TRUE);
	m_Comm.SetPortOpen(TRUE);
	m_Comm.SetInputMode(1);

	count=0;
	in=0;
	out=0;

	//m_sNRdDataHex.Format("%04X", 255);
	// Update the dialog
	//UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


int CNovramRdDlg::Buffer_Empty_Q()
{
	/* Return <> 0  if buffer is empty */
	return(count == 0);	
}

BYTE CNovramRdDlg::Dequeue_Buffer()
{
  /* Returns a byte from queue, MUST NOT BE EMPTY! */
  count--;
  out++;
  if ( out == 255 )
	 out = 0;
  return data[out] ;
}

void CNovramRdDlg::RcvCOM()
{
	COleVariant myVar;
	int hr;
	long lLen=0;
	myVar=m_Comm.GetInput();
	hr=SafeArrayGetUBound(myVar.parray, 1, &lLen);
	if( hr==S_OK)
	{
		lLen++;	//upper bound is zero based index
		// lock array so you can access it
		BYTE *pAccess;
		hr=SafeArrayAccessData(myVar.parray, (void**)&pAccess);

		if(hr==S_OK)
		{
			// Make a copy of data
			// Note: Need to check that lLen is < buffer length
			// so you don't overrun the buffer.
			for( int i=0; i<lLen; i++)
			{
				if(count<255)
				{
					count++;
					in++;
					if(in==255)
					  in=0;
					data[in]=pAccess[i];
				}
			}
			// unlock the data
			SafeArrayUnaccessData(myVar.parray);
		}
	}
}

void CNovramRdDlg::XmtCOM(unsigned char b)
{
	CByteArray arrBytes;
	arrBytes.Add(b);
	m_Comm.SetOutput(COleVariant(arrBytes));
}

void CNovramRdDlg::OnOk() 
{
	// TODO: Add your control notification handler code here

	BYTE IDcmd, EchoB, StatusB;
	BYTE HiB, LoB;
	int AddrI, DataI;

	time_t start, finish;
	long timeout;
	double elapsed_time;
	
	// Update the variable. Before Reading.
	UpdateData(TRUE);
	timeout=m_lNRdTOut;		//2s
	// Update the variable.
//	UpdateData(TRUE);
	AddrI=m_iNRdAddress;

	SetDlgItemText(IDC_NRDSTATUS,"0");
	SetDlgItemText(IDC_NRDCANCEL,"0");

	m_cOK.EnableWindow(FALSE);
	
	IDcmd=56;
	XmtCOM(IDcmd);
	time( &start );
	do
	{
		RcvCOM();
		time( &finish );
		elapsed_time = difftime( finish, start );
	}
	while((Buffer_Empty_Q())&&(elapsed_time < timeout));
	if(elapsed_time < timeout)
	{
		EchoB=Dequeue_Buffer();
		if(EchoB != IDcmd)
		{
			MessageBox("An error has occurred !",
				"NO EchoByte",
				MB_ICONSTOP);
		}

		XmtCOM(AddrI);

		while(Buffer_Empty_Q())
			RcvCOM();
		HiB=Dequeue_Buffer();
		while(Buffer_Empty_Q())
			RcvCOM();
		LoB=Dequeue_Buffer();

		while(Buffer_Empty_Q())
			RcvCOM();
		StatusB=Dequeue_Buffer();
		m_iNRdStatus=StatusB;
		// Update dialog
		UpdateData(FALSE);

		while(Buffer_Empty_Q())
			RcvCOM();
		m_iNRdCancel=Dequeue_Buffer();
		// Update dialog
		UpdateData(FALSE);
		
		DataI=HiB*256+LoB;
		m_iNRdData=DataI;
		m_sNRdDataHex.Format("%04X", DataI);
		// Update dialog
		UpdateData(FALSE);

		if (StatusB <= 127)
		{}
		else
		{
			if ( (StatusB & 64)==0)
			MessageBox("An error has occurred !",
				"Status >= 128",
				MB_ICONSTOP);
			else
			{}
		}
	
	}
	else
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	m_cOK.EnableWindow(TRUE);
	
}
