// NWrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "NWrDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNWrDlg dialog

extern int gblPortNo;
extern int count;
extern int in;
extern int out;
extern BYTE data[255];


CNWrDlg::CNWrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNWrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNWrDlg)
	m_iNWrAddress = 3;
	m_iNWrCancel = 0;
	m_iNWrData = 0;
	m_sNWrDataHex = _T("0");
	m_iNWrStatus = 0;
	m_lNWrTOut = 2;
	//}}AFX_DATA_INIT
}


void CNWrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNWrDlg)
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Control(pDX, IDC_MSCOMM1, m_Comm);
	DDX_Text(pDX, IDC_NWRADDRESS, m_iNWrAddress);
	DDV_MinMaxInt(pDX, m_iNWrAddress, 1, 64);
	DDX_Text(pDX, IDC_NWRCANCEL, m_iNWrCancel);
	DDX_Text(pDX, IDC_NWRDATA, m_iNWrData);
	DDV_MinMaxInt(pDX, m_iNWrData, 0, 65535);
	DDX_Text(pDX, IDC_NWRDATAHEX, m_sNWrDataHex);
	DDX_Text(pDX, IDC_NWRSTATUS, m_iNWrStatus);
	DDX_Text(pDX, IDC_NWRTOUT, m_lNWrTOut);
	DDV_MinMaxLong(pDX, m_lNWrTOut, 0, 3599);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNWrDlg, CDialog)
	//{{AFX_MSG_MAP(CNWrDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNWrDlg message handlers




BOOL CNWrDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	m_Comm.SetCommPort(gblPortNo);
	m_Comm.SetSettings("9600,n,8,1");
	m_Comm.SetRTSEnable(TRUE);
	m_Comm.SetPortOpen(TRUE);
	m_Comm.SetInputMode(1);

	count=0;
	in=0;
	out=0;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

int CNWrDlg::Buffer_Empty_Q()
{
	/* Return <> 0  if buffer is empty */
	return(count == 0);	
}

BYTE CNWrDlg::Dequeue_Buffer()
{
  /* Returns a byte from queue, MUST NOT BE EMPTY! */
  count--;
  out++;
  if ( out == 255 )
	 out = 0;
  return data[out] ;
}

void CNWrDlg::RcvCOM()
{
	COleVariant myVar;
	int hr;
	long lLen=0;
	myVar=m_Comm.GetInput();
	hr=SafeArrayGetUBound(myVar.parray, 1, &lLen);
	if( hr==S_OK)
	{
		lLen++;	//upper bound is zero based index
		// lock array so you can access it
		BYTE *pAccess;
		hr=SafeArrayAccessData(myVar.parray, (void**)&pAccess);

		if(hr==S_OK)
		{
			// Make a copy of data
			// Note: Need to check that lLen is < buffer length
			// so you don't overrun the buffer.
			for( int i=0; i<lLen; i++)
			{
				if(count<255)
				{
					count++;
					in++;
					if(in==255)
					  in=0;
					data[in]=pAccess[i];
				}
			}
			// unlock the data
			SafeArrayUnaccessData(myVar.parray);
		}
	}
}

void CNWrDlg::XmtCOM(unsigned char b)
{
	CByteArray arrBytes;
	arrBytes.Add(b);
	m_Comm.SetOutput(COleVariant(arrBytes));
}

void CNWrDlg::OnOk() 
{
	// TODO: Add your control notification handler code here

	BYTE IDcmd, EchoB, StatusB;
	BYTE HiB, LoB;
	int AddrI, DataI;
	BYTE ChkSumB;

	time_t start, finish;
	long timeout;
	double elapsed_time;
	
	// Update the variable. Before Reading.
	UpdateData(TRUE);
	timeout=m_lNWrTOut;		//2s

	AddrI=m_iNWrAddress;
	DataI=m_iNWrData;

	m_sNWrDataHex.Format("%04X", DataI);
	// Update dialog
	UpdateData(FALSE);

	SetDlgItemText(IDC_NWRSTATUS,"0");
	SetDlgItemText(IDC_NWRCANCEL,"0");

	m_cOK.EnableWindow(FALSE);
	
	IDcmd=59;
	XmtCOM(IDcmd);
	time( &start );
	do
	{
		RcvCOM();
		time( &finish );
		elapsed_time = difftime( finish, start );
	}
	while((Buffer_Empty_Q())&&(elapsed_time < timeout));
	if(elapsed_time < timeout)
	{
		EchoB=Dequeue_Buffer();
		if(EchoB != IDcmd)
		{
			MessageBox("An error has occurred !",
				"NO EchoByte",
				MB_ICONSTOP);
		}

		HiB=DataI / 256;
		LoB=(DataI - 256 * HiB);
		ChkSumB=AddrI+HiB+LoB;

		XmtCOM(AddrI); XmtCOM(HiB); XmtCOM(LoB); XmtCOM(ChkSumB);

		while(Buffer_Empty_Q())
			RcvCOM();
		StatusB=Dequeue_Buffer();
		m_iNWrStatus=StatusB;
		// Update dialog
		UpdateData(FALSE);

		while(Buffer_Empty_Q())
			RcvCOM();
		m_iNWrCancel=Dequeue_Buffer();
		// Update dialog
		UpdateData(FALSE);

		//m_sNRdDataHex.Format("%04X", DataI);
		// Update dialog
		//UpdateData(FALSE);

		if (StatusB <= 127)
		{}
		else
		{
			if ( (StatusB & 64)==0)
			MessageBox("An error has occurred !",
				"Status >= 128",
				MB_ICONSTOP);
			else
			{}
		}
	
	}
	else
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	m_cOK.EnableWindow(TRUE);

}

