// ScanDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "ScanDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScanDlg dialog

extern int gblPortNo;
extern int count;
extern int in;
extern int out;
extern BYTE data[255];
extern long gblCurWL;

CScanDlg::CScanDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScanDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScanDlg)
	m_iScanCancel = 0;
	m_iScanStatus = 0;
	m_lScanWL0 = 0;
	m_lScanWL1 = 0;
	m_lScanTOut = 2;
	//}}AFX_DATA_INIT
}


void CScanDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScanDlg)
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Control(pDX, IDC_MSCOMM1, m_Comm);
	DDX_Text(pDX, IDC_SCANCANCEL, m_iScanCancel);
	DDX_Text(pDX, IDC_SCANSTATUS, m_iScanStatus);
	DDX_Text(pDX, IDC_SCANWL0, m_lScanWL0);
	DDX_Text(pDX, IDC_SCANWL1, m_lScanWL1);
	DDV_MinMaxLong(pDX, m_lScanWL1, 0, 16777215);
	DDX_Text(pDX, IDC_SCANTOUT, m_lScanTOut);
	DDV_MinMaxLong(pDX, m_lScanTOut, 0, 3599);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScanDlg, CDialog)
	//{{AFX_MSG_MAP(CScanDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScanDlg message handlers

BOOL CScanDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	m_Comm.SetCommPort(gblPortNo);
	m_Comm.SetSettings("9600,n,8,1");
	m_Comm.SetRTSEnable(TRUE);
	m_Comm.SetPortOpen(TRUE);
	m_Comm.SetInputMode(1);

	count=0;
	in=0;
	out=0;
	
	m_lScanWL0=gblCurWL;
	// Update the dialog
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

int CScanDlg::Buffer_Empty_Q()
{
	/* Return <> 0  if buffer is empty */
	return(count == 0);	
}

BYTE CScanDlg::Dequeue_Buffer()
{
  /* Returns a byte from queue, MUST NOT BE EMPTY! */
  count--;
  out++;
  if ( out == 255 )
	 out = 0;
  return data[out] ;
}

void CScanDlg::RcvCOM()
{
	COleVariant myVar;
	int hr;
	long lLen=0;
	myVar=m_Comm.GetInput();
	hr=SafeArrayGetUBound(myVar.parray, 1, &lLen);
	if( hr==S_OK)
	{
		lLen++;	//upper bound is zero based index
		// lock array so you can access it
		BYTE *pAccess;
		hr=SafeArrayAccessData(myVar.parray, (void**)&pAccess);

		if(hr==S_OK)
		{
			// Make a copy of data
			// Note: Need to check that lLen is < buffer length
			// so you don't overrun the buffer.
			for( int i=0; i<lLen; i++)
			{
				if(count<255)
				{
					count++;
					in++;
					if(in==255)
					  in=0;
					data[in]=pAccess[i];
				}
			}
			// unlock the data
			SafeArrayUnaccessData(myVar.parray);
		}
	}

}

void CScanDlg::XmtCOM(unsigned char b)
{
	CByteArray arrBytes;
	arrBytes.Add(b);
	m_Comm.SetOutput(COleVariant(arrBytes));
}


void CScanDlg::OnOk() 
{
	// TODO: Add your control notification handler code here

	// VB use time 100s. Use 2ms for Echo only
	BYTE IDcmd, EchoB, StatusB, CancelB;
	BYTE HiB, MiB, LoB;

	time_t start, finish;
	long timeout;
	double elapsed_time;

	// Update the variable to get m_lScanWL
	UpdateData(TRUE);
	timeout=m_lScanTOut;		//2s

	SetDlgItemText(IDC_SCANSTATUS,"0");
	SetDlgItemText(IDC_SCANCANCEL,"0");

	m_cOK.EnableWindow(FALSE);
	
	IDcmd=12;
	XmtCOM(IDcmd);
	time( &start );
	do
	{
		RcvCOM();
		time( &finish );
		elapsed_time = difftime( finish, start );
	}
	while((Buffer_Empty_Q())&&(elapsed_time < timeout));
	if(elapsed_time < timeout)
	{
		EchoB=Dequeue_Buffer();
		if(EchoB != IDcmd)
		{
			MessageBox("An error has occurred !",
				"NO EchoByte",
				MB_ICONSTOP);
		}

		HiB=m_lScanWL1 / 65536;
		MiB=(m_lScanWL1 - 65536 * HiB) / 256 ;
		LoB=(m_lScanWL1 - (65536 * HiB + 256 * MiB));

		XmtCOM(HiB);	XmtCOM(MiB);	XmtCOM(LoB);

		while(Buffer_Empty_Q())
			RcvCOM();
		StatusB=Dequeue_Buffer();
		m_iScanStatus=StatusB;
		// Update dialog
		UpdateData(FALSE);

		while(Buffer_Empty_Q())
			RcvCOM();
		CancelB = Dequeue_Buffer();
		m_iScanCancel = CancelB;
		// Update dialog
		UpdateData(FALSE);

		if (StatusB <= 127)
		{
			gblCurWL = m_lScanWL1;
		}
		else
		{
			if ( (StatusB & 64)==0)
			MessageBox("An error has occurred !",
				"Status >= 128",
				MB_ICONSTOP);
			else
				gblCurWL = m_lScanWL1;
		}
	
	}
	else
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	m_cOK.EnableWindow(TRUE);
}
