// SlitCalDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "SlitCalDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSlitCalDlg dialog

extern int gblPortNo;
extern int count;
extern int in;
extern int out;
extern BYTE data[255];
extern int gblS1, gblS2;


CSlitCalDlg::CSlitCalDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSlitCalDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSlitCalDlg)
	m_iSlit1Cal = 0;
	m_iSlit2Cal = 0;
	m_iSlitCalBtn1 = -1;
	m_iSlitCalCancel = 0;
	m_iSlitCalStatus = 0;
	m_lSlitCalTOut = 2;
	//}}AFX_DATA_INIT
}


void CSlitCalDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSlitCalDlg)
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Control(pDX, IDC_MSCOMM1, m_Comm);
	DDX_Text(pDX, IDC_SLIT1CAL, m_iSlit1Cal);
	DDX_Text(pDX, IDC_SLIT2CAL, m_iSlit2Cal);
	DDX_Radio(pDX, IDC_SLITCALBTN1, m_iSlitCalBtn1);
	DDX_Text(pDX, IDC_SLITCALCANCEL, m_iSlitCalCancel);
	DDX_Text(pDX, IDC_SLITCALSTATUS, m_iSlitCalStatus);
	DDX_Text(pDX, IDC_SLITCALTOUT, m_lSlitCalTOut);
	DDV_MinMaxLong(pDX, m_lSlitCalTOut, 0, 3599);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSlitCalDlg, CDialog)
	//{{AFX_MSG_MAP(CSlitCalDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	ON_BN_CLICKED(IDC_SLITCALBTN1, OnSlitcalbtn1)
	ON_BN_CLICKED(IDC_SLITCALBTN2, OnSlitcalbtn2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSlitCalDlg message handlers

BOOL CSlitCalDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	m_Comm.SetCommPort(gblPortNo);
	m_Comm.SetSettings("9600,n,8,1");
	m_Comm.SetRTSEnable(TRUE);
	m_Comm.SetPortOpen(TRUE);
	m_Comm.SetInputMode(1);

	count=0;
	in=0;
	out=0;

	// m_iSlitAdj[2]	S1: 0, S2: 1
	m_iSlitCal[0].SubclassDlgItem(IDC_SLIT1CAL, this);
	m_iSlitCal[1].SubclassDlgItem(IDC_SLIT2CAL, this);

	m_iSlitCalBtn1=0;

	m_iSlit1Cal = gblS1;
	m_iSlit2Cal = gblS2;
	// Update the dialog
	UpdateData(FALSE);
	OnSlitcalbtn1();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

int CSlitCalDlg::Buffer_Empty_Q()
{
	/* Return <> 0  if buffer is empty */
	return(count == 0);	
}

BYTE CSlitCalDlg::Dequeue_Buffer()
{
  /* Returns a byte from queue, MUST NOT BE EMPTY! */
  count--;
  out++;
  if ( out == 255 )
	 out = 0;
  return data[out] ;
}

void CSlitCalDlg::RcvCOM()
{
	COleVariant myVar;
	int hr;
	long lLen=0;
	myVar=m_Comm.GetInput();
	hr=SafeArrayGetUBound(myVar.parray, 1, &lLen);
	if( hr==S_OK)
	{
		lLen++;	//upper bound is zero based index
		// lock array so you can access it
		BYTE *pAccess;
		hr=SafeArrayAccessData(myVar.parray, (void**)&pAccess);

		if(hr==S_OK)
		{
			// Make a copy of data
			// Note: Need to check that lLen is < buffer length
			// so you don't overrun the buffer.
			for( int i=0; i<lLen; i++)
			{
				if(count<255)
				{
					count++;
					in++;
					if(in==255)
					  in=0;
					data[in]=pAccess[i];
				}
			}
			// unlock the data
			SafeArrayUnaccessData(myVar.parray);
		}
	}
}

void CSlitCalDlg::XmtCOM(unsigned char b)
{
	CByteArray arrBytes;
	arrBytes.Add(b);
	m_Comm.SetOutput(COleVariant(arrBytes));
}


void CSlitCalDlg::OnSlitcalbtn1() 
{
	// TODO: Add your control notification handler code here
		m_iSlitCal[0].EnableWindow(TRUE);
		m_iSlitCal[1].EnableWindow(FALSE);
		m_iSlitCalBtn1=0;
}

void CSlitCalDlg::OnSlitcalbtn2() 
{
	// TODO: Add your control notification handler code here
		m_iSlitCal[0].EnableWindow(FALSE);
		m_iSlitCal[1].EnableWindow(TRUE);
		m_iSlitCalBtn1=1;
}

void CSlitCalDlg::OnOk() 
{
	// TODO: Add your control notification handler code here

	BYTE IDcmd, EchoB, StatusB;
	BYTE HiB, LoB;
	int iSlitNew;

	time_t start, finish;
	long timeout;
	double elapsed_time;

	// Update the variable
	UpdateData(TRUE);
	timeout=m_lSlitCalTOut;		//2s

	SetDlgItemText(IDC_SLITCALSTATUS,"0");
	SetDlgItemText(IDC_SLITCALCANCEL,"0");

	switch(m_iSlitCalBtn1)
	{
	case 0:
		IDcmd=22;	// Entrance slit (S1)
		iSlitNew = m_iSlit1Cal;
		break;
	case 1:
		IDcmd=23;	// Exit slit (S2)
		iSlitNew = m_iSlit2Cal;
		break;
	default:
		IDcmd=23;	// Exit slit (S2)
		iSlitNew = m_iSlit2Cal;
		break;
	}
	// Update the variable
	UpdateData(TRUE);

	XmtCOM(IDcmd);
	time( &start );
	do
	{
		RcvCOM();
		time( &finish );
		elapsed_time = difftime( finish, start );
	}
	while((Buffer_Empty_Q())&&(elapsed_time < timeout));
	if(elapsed_time < timeout)
	{
		EchoB=Dequeue_Buffer();
		if(EchoB != IDcmd)
		{
			MessageBox("An error has occurred !",
				"NO EchoByte",
				MB_ICONSTOP);
		}

		HiB=iSlitNew / 256;
		LoB=(iSlitNew - 256 * HiB);
		
		XmtCOM(HiB);	XmtCOM(LoB);

		while(Buffer_Empty_Q())
			RcvCOM();
		StatusB=Dequeue_Buffer();
		m_iSlitCalStatus=StatusB;
		// Update dialog
		UpdateData(FALSE);

		while(Buffer_Empty_Q())
			RcvCOM();
		m_iSlitCalCancel=Dequeue_Buffer();
		// Update dialog
		UpdateData(FALSE);

		if (StatusB <= 127)
		{
			UpdateGblSlit( m_iSlitCalBtn1, iSlitNew );
		}
		else
		{
			if ( (StatusB & 64)==0)
			MessageBox("An error has occurred !",
				"Status >= 128",
				MB_ICONSTOP);
			else
				UpdateGblSlit( m_iSlitCalBtn1, iSlitNew );
		}
	
	}
	else
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	
}


void CSlitCalDlg::UpdateGblSlit(int SlitN, int SlitNew)
{
	switch(SlitN)
	{
	case 0:
		gblS1 = SlitNew;
		break;
	case 1:
		gblS2 = SlitNew;
		break;
	default:
		gblS2 = SlitNew;
		break;
	}
	// Update the dialog
	UpdateData(FALSE);
}
