// ZeroDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "ZeroDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CZeroDlg dialog

extern int gblPortNo;
extern int count;
extern int in;
extern int out;
extern BYTE data[255];
extern long gblCurWL;
extern long gblNGrtSelted;	//Number of grating selected.

// global, declaration in this file
int StepFrom0M1;


CZeroDlg::CZeroDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CZeroDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CZeroDlg)
	m_iOffsetM1 = 0;
	m_iStepM1 = 0;
	m_iZeroCancel = 0;
	m_iZeroStatus = 0;
	m_lZeroTOut = 2;
	//}}AFX_DATA_INIT
}


void CZeroDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZeroDlg)
	DDX_Control(pDX, IDC_STEPDNM1, m_cStepDnM1);
	DDX_Control(pDX, IDC_STEPUPM1, m_cStepUpM1);
	DDX_Control(pDX, IDC_MSCOMM1, m_Comm);
	DDX_Text(pDX, IDC_OFFSETM1, m_iOffsetM1);
	DDV_MinMaxInt(pDX, m_iOffsetM1, 0, 65535);
	DDX_Text(pDX, IDC_STEPM1, m_iStepM1);
	DDX_Text(pDX, IDC_ZEROCANCEL, m_iZeroCancel);
	DDX_Text(pDX, IDC_ZEROSTATUS, m_iZeroStatus);
	DDX_Text(pDX, IDC_ZEROTOUT, m_lZeroTOut);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CZeroDlg, CDialog)
	//{{AFX_MSG_MAP(CZeroDlg)
	ON_BN_CLICKED(IDC_ZERO, OnZero)
	ON_BN_CLICKED(IDC_STEPUPM1, OnStepupm1)
	ON_BN_CLICKED(IDC_STEPDNM1, OnStepdnm1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZeroDlg message handlers


BOOL CZeroDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	m_Comm.SetCommPort(gblPortNo);
	m_Comm.SetSettings("9600,n,8,1");
	m_Comm.SetRTSEnable(TRUE);
	m_Comm.SetPortOpen(TRUE);
	m_Comm.SetInputMode(1);

	count=0;
	in=0;
	out=0;

	StepFrom0M1 = 0;

	WORD OffsetM1;

	Queries( &OffsetM1 );
	m_iOffsetM1 = OffsetM1;
	// Updata the dialog
	UpdateData(FALSE);

	if(gblCurWL)
	{
		if(GotoZero()==0)
			gblCurWL=0;
	}


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


int CZeroDlg::Buffer_Empty_Q()
{
	/* Return <> 0  if buffer is empty */
	return(count == 0);	
}


BYTE CZeroDlg::Dequeue_Buffer()
{
  /* Returns a byte from queue, MUST NOT BE EMPTY! */
  count--;
  out++;
  if ( out == 255 )
	 out = 0;
  return data[out] ;
}


void CZeroDlg::RcvCOM()
{
	COleVariant myVar;
	int hr;
	long lLen=0;
	myVar=m_Comm.GetInput();
	hr=SafeArrayGetUBound(myVar.parray, 1, &lLen);
	if( hr==S_OK)
	{
		lLen++;	//upper bound is zero based index
		// lock array so you can access it
		BYTE *pAccess;
		hr=SafeArrayAccessData(myVar.parray, (void**)&pAccess);

		if(hr==S_OK)
		{
			// Make a copy of data
			// Note: Need to check that lLen is < buffer length
			// so you don't overrun the buffer.
			for( int i=0; i<lLen; i++)
			{
				if(count<255)
				{
					count++;
					in++;
					if(in==255)
					  in=0;
					data[in]=pAccess[i];
				}
			}
			// unlock the data
			SafeArrayUnaccessData(myVar.parray);
		}
	}
}


void CZeroDlg::XmtCOM(unsigned char b)
{
	CByteArray arrBytes;
	arrBytes.Add(b);
	m_Comm.SetOutput(COleVariant(arrBytes));
}


void CZeroDlg::OnZero() 
{
	// TODO: Add your control notification handler code here

	BYTE IDcmd, EchoB, StatusB;
	BYTE TurretB;

	time_t start, finish;
	long timeout;
	double elapsed_time;

	// Update the variable
	UpdateData(TRUE);
	timeout=m_lZeroTOut;		//2s

	SetDlgItemText(IDC_ZEROSTATUS,"0");
	SetDlgItemText(IDC_ZEROCANCEL,"0");
	
	TurretB=1;
	IDcmd=52;
	XmtCOM(IDcmd);
	time( &start );
	do
	{
		RcvCOM();
		time( &finish );
		elapsed_time = difftime( finish, start );
	}
	while((Buffer_Empty_Q())&&(elapsed_time < timeout));
	if(elapsed_time < timeout)
	{
		EchoB=Dequeue_Buffer();
		if(EchoB != IDcmd)
		{
			MessageBox("An error has occurred !",
				"NO EchoByte",
				MB_ICONSTOP);
		}

		XmtCOM(TurretB);

		while(Buffer_Empty_Q())
			RcvCOM();
		StatusB=Dequeue_Buffer();
		m_iZeroStatus=StatusB;
		// Update dialog
		UpdateData(FALSE);

		while(Buffer_Empty_Q())
			RcvCOM();
		m_iZeroCancel=Dequeue_Buffer();
		// Update dialog
		UpdateData(FALSE);

		if (StatusB <= 127)
		{
			WORD OffsetM1;
			Queries( &OffsetM1 );
			m_iOffsetM1 = OffsetM1;
			StepFrom0M1=0;
			m_iStepM1=0;
			// Update dialog
			UpdateData(FALSE);
		}
		else
		{
			if ( (StatusB & 64)==0)
			MessageBox("An error has occurred !",
				"Status >= 128",
				MB_ICONSTOP);
			else
			{
				WORD OffsetM1;
				Queries( &OffsetM1 );
				m_iOffsetM1 = OffsetM1;
				StepFrom0M1=0;
				m_iStepM1=0;
				// Update dialog
				UpdateData(FALSE);
			}
		}
	
	}
	else
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}

}


void CZeroDlg::OnCancel() 
{
	// TODO: Add extra cleanup here

	if(StepFrom0M1)
	{
		if(GotoZero()==0)
			gblCurWL=0;
	}
	CDialog::OnCancel();
}



int CZeroDlg::GotoZero()
{
	// Return Zero if NO error
	int rtnI;
	rtnI=128;	// Yes, error

	BYTE IDcmd, EchoB, StatusB, CancelB;
	
	time_t start, finish;
	long timeout;
	double elapsed_time;
	timeout=2;		//2s
	
	IDcmd=16;
	XmtCOM(IDcmd);
	time( &start );
	do
	{
		RcvCOM();
		time( &finish );
		elapsed_time = difftime( finish, start );
	}
	while((Buffer_Empty_Q())&&(elapsed_time < timeout));
	if(elapsed_time < timeout)
	{
		EchoB=Dequeue_Buffer();
		if(EchoB != IDcmd)
		{
			MessageBox("An error has occurred !",
				"NO EchoByte",
				MB_ICONSTOP);
		}

		XmtCOM(0);	XmtCOM(0);	XmtCOM(0);

		while(Buffer_Empty_Q())
			RcvCOM();
		StatusB=Dequeue_Buffer();

		while(Buffer_Empty_Q())
			RcvCOM();
		CancelB=Dequeue_Buffer();

		if (StatusB <= 127)
		{
			rtnI=0;		// No error
		}
		else
		{
			if ( (StatusB & 64)==0)
			MessageBox("An error has occurred !",
				"Status >= 128",
				MB_ICONSTOP);
			else
				rtnI=0;		// No error
		}
	
	}
	else
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	return rtnI;
}


void CZeroDlg::Queries(WORD *OffsetM1)
{
	BYTE MIndex;	// The index of current grating select.
	MIndex=gblNGrtSelted - 1;	//Number of grating selected.
	

	BYTE IDcmd, EchoB, StatusB, CancelB;
	BYTE HiB, LoB, AddrB;
	WORD DataW;

	time_t start, finish;
	long timeout;
	double elapsed_time;
	timeout= 2;		//2s
	
	AddrB=14 + MIndex; 
	IDcmd=56;
	XmtCOM(IDcmd);
	time( &start );
	do
	{
		RcvCOM();
		time( &finish );
		elapsed_time = difftime( finish, start );
	}
	while((Buffer_Empty_Q())&&(elapsed_time < timeout));
	if(elapsed_time < timeout)
	{
		EchoB=Dequeue_Buffer();
		if(EchoB != IDcmd)
		{
			MessageBox("An error has occurred !",
				"NO EchoByte",
				MB_ICONSTOP);
		}

		XmtCOM(AddrB);
		while(Buffer_Empty_Q())
			RcvCOM();
		HiB=Dequeue_Buffer();
		while(Buffer_Empty_Q())
			RcvCOM();
		LoB=Dequeue_Buffer();
		DataW= HiB*256 + LoB;

		while(Buffer_Empty_Q())
			RcvCOM();
		StatusB=Dequeue_Buffer();
		while(Buffer_Empty_Q())
			RcvCOM();
		CancelB=Dequeue_Buffer();

		*OffsetM1 = DataW;
	}
	else
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}

}


void CZeroDlg::OnStepupm1() 
{
	// TODO: Add your control notification handler code here

	if(StepUpDn(7) == 0)
		m_iStepM1 = ++StepFrom0M1;
	// Update the dialog
	UpdateData(FALSE);
}


void CZeroDlg::OnStepdnm1() 
{
	// TODO: Add your control notification handler code here
	if(StepUpDn(1) == 0)
		m_iStepM1 = --StepFrom0M1;
	// Update the dialog
	UpdateData(FALSE);
}


int CZeroDlg::StepUpDn(BYTE Cmd)
{
	// Return 0 if no error
	BYTE IDcmd, EchoB, StatusB, CancelB;
	int rtnI;

	time_t start, finish;
	long timeout;
	double elapsed_time;

	timeout=2;		//2s
	rtnI = 128;		// Yes error
	
	IDcmd=Cmd;
	XmtCOM(IDcmd);
	time( &start );
	do
	{
		RcvCOM();
		time( &finish );
		elapsed_time = difftime( finish, start );
	}
	while((Buffer_Empty_Q())&&(elapsed_time < timeout));
	if(elapsed_time < timeout)
	{
		EchoB=Dequeue_Buffer();
		if(EchoB != IDcmd)
		{
			MessageBox("An error has occurred !",
				"NO EchoByte",
				MB_ICONSTOP);
		}

		while(Buffer_Empty_Q())
			RcvCOM();
		StatusB=Dequeue_Buffer();

		while(Buffer_Empty_Q())
			RcvCOM();
		CancelB=Dequeue_Buffer();

		if (StatusB <= 127)
		{
			rtnI = 0;	// No error
		}
		else
		{
			if ( (StatusB & 64)==0)
			MessageBox("An error has occurred !",
				"Status >= 128",
				MB_ICONSTOP);
			else
				rtnI = 0;	// No error
		}
	
	}
	else
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	return rtnI;
}

